#!/usr/local/bin/bash
if [ x$1 = x ]; then
	echo "Esegue il controllo della memoria."
	echo "Occorre compilare l'applicazione da testare con -DUSEMALLOCHOOK -DDETECT_MEMLEAK"
	echo "Usare $0 [1m<nomeApplicazioneTest> <parametri>[0m"
	echo "ESEMPIO: $0 ./TestApp -x:2n ../CFG/_local/GR_V.cfg"
	exit 1;
fi

export AGL_RTMEMCHECK=01110100
#  		      76543210
#		      |||||||+- heap used (sbrk(0))
#		      ||||||+--- every call dumped
#		      |||||+----- mem leak
#		      ||||+------- head overwrite
#		      |||+--------- tail overwrite
#		      ||+----------- free unallocated mem
#		      |+------------- check only new/delete
#		      + -------------- new/delete[] mismatch

export LEAKTRACE_REPORT=report.txt
# modificare qui il nome del file di report
export LT_ABORTREASON=0
# 0=mai, 1=overwrite, 2=delete multipla, 4=mismatch fra delete[]
export LEAKTRACE_FILE=leak.out
# modificare qui il nome del file con i comandi GDB
rm -f $LEAKTRACE_FILE
echo Esegui il programma di test fornendo gli input desiderati ed infine esci.
#$@ <<EOF
#e
#EOF
echo "Lancio $@"
$@
#export AGL_RTMEMCHECK=00000000
echo "Creazione del report in corso. Attendere ..."
rm -f dummy
export LEAKTRACE_FILE=dummy
gdb < leak.out > $LEAKTRACE_REPORT -quiet --args $@ 
rm -f dummy
echo "Il report e' in $LEAKTRACE_REPORT."
pkill -9 -f $1